#include <iostream>
#include <assert.h>
#include "bitmap.h"
#include<cstdlib>


// Defining  the simple windows
SimpleWindow W1("SPOT AND HIT", 14.0, 14.0, Position(1.0, 1.0)); //Main Window W1
SimpleWindow W2(" SPOT AND HIT ", 14.0, 14.0, Position(7.0, 1.0));//Game Window W2
SimpleWindow W3(" SPOT AND HIT ", 20.0, 20.0, Position(1.0, 1.0));//Instructions Window

// Define the bitmap objects 

//Bitmaps on the main window
BitMap WMBmp(W1); //Background bitmap
BitMap W1Bmp(W1); //Start Bitmap
BitMap W2Bmp(W1); //Quit Bitmap
BitMap W7Bmp(W1); //Intsructions Bitmap

BitMap W8Bmp(W1);
BitMap W9Bmp(W1);
BitMap W10Bmp(W1);

//Bitmaps for the game window
BitMap W3Bmp(W2);
BitMap W4Bmp(W2);
BitMap W5Bmp(W2);
BitMap W6Bmp(W2);


int count=0; //This variable represents the player's score at all times
int bad=0,good=0,aimless=0; //Variables for grouping the clicks made by the player in a game.


//Function that stops the game when time limit is reached
int W2close()
{
W2.Message("Thats it ! Your time is up !!!");
W2.Close();
W2.Message(" Goodbye Player. Have a nice day");
W1.Close();
//The Windows are closed and the final score is displayed
cout<<endl<<" --------------- PLAYER's Performance STATISTICS ---------------"<<endl;
cout<<" No. Of 'Good' Hits : "<<good<<endl;
cout<<" No. Of 'Bad' Hits : "<<bad<<endl;
cout<<" No. Of 'Aimless' Hits :"<<aimless<<endl;
cout<<endl<<" FINAL SCORE :: "<<count<<endl<<endl;
cout<<"Nice playing with you"<<endl;
cout<<"See you soon.....Goodbye!"<<endl;
return 0;
}


//Function that randomly displays images in various positions on the screen
void display(SimpleWindow &W, BitMap &B)
{ 
int x,y;
B.Erase();
x=rand()%11+1;
y=rand()%11+1;
B.SetPosition(Position(x,y));
B.Draw();
}


//Function that is called upon by the timer which inturn invokes the "display()" function
int W2TimerEvent()
{ 

int x=rand()%4+1;

if(x==1)
{ W4Bmp.Erase();
  W5Bmp.Erase();
  W6Bmp.Erase();
 display(W2,W3Bmp);
}
else if(x==2)
{  W3Bmp.Erase();
   W5Bmp.Erase();
   W6Bmp.Erase();
  display(W2,W4Bmp);
}

else if(x==3)
{  
   W3Bmp.Erase();
   W4Bmp.Erase();
   W6Bmp.Erase();
   display(W2,W5Bmp);
}
else if(x==4)
{  
   W3Bmp.Erase();
   W4Bmp.Erase();
   W5Bmp.Erase();
   display(W2,W6Bmp);
}

return 1;
}


//Function that scores the player based on his mouseclicks
//Score of the player is displayed after every mouseclick
//Score is based on the type of ball the player hits
int Mouseclick1(const Position &p)
{     
if(W3Bmp.IsInside(p))
{ count=count+3;  good++;
cout<<"Now your score is::"<<count<<"\a"<<endl;
}
else if(W4Bmp.IsInside(p))
{ count=count-2;   bad++;
cout<<"Now your score is::"<<count<<"\a"<<endl;
}
else if(W5Bmp.IsInside(p))
{ count=count+1;     good++;
cout<<"Now your score is::"<<count<<"\a"<<endl;
}

else if(W6Bmp.IsInside(p))
{ count=count-1;    bad++;
cout<<"Now your score is::"<<count<<"\a"<<endl;
}


else {count=count-1; aimless++; cout<<"Aimless click ! So now your score is  :: "<<count<<endl; } //Aimless clicks are penalised


//Speed increases as the score increases
if(count>=2&&count<=4)
{ 
W2.StopTimer();
W2.SetTimerCallback(W2TimerEvent);
bool TimerStatus = W2.StartTimer(850);
assert(TimerStatus);
}
else if(count>=5&&count<=8)
{ 
W2.StopTimer();
W2.SetTimerCallback(W2TimerEvent);
bool TimerStatus = W2.StartTimer(750);
assert(TimerStatus);
}

else if(count>8&&count<=11)
{ 
W2.StopTimer();
W2.SetTimerCallback(W2TimerEvent);
bool TimerStatus = W2.StartTimer(650);
assert(TimerStatus);
}

else if(count>11)
{
W2.StopTimer();
W2.SetTimerCallback(W2TimerEvent);
bool TimerStatus = W2.StartTimer(450);
assert(TimerStatus);
}

return 1;
}


//Function that starts the game after the user hits "Start"
void gameinit()
{ 
W2.Message("Get Ready ! The game is going to begin"); 
  
  W2.Open();  //Game window is opened
  assert(W2.GetStatus() == WindowOpen);

       //Load the  first bitmap
        W3Bmp.Load("smallblue.xpm"); //Initial bitmap image is loaded
	assert(W3Bmp.GetStatus() == BitMapOkay);

	// Display the bit maps at a starting position
	W3Bmp.SetPosition(Position(1.0, 1.0));
	W3Bmp.Draw();
     
         
        //Load the Second Bitmap
        W4Bmp.Load("red.xpm"); //Initial bitmap image is loaded
	assert(W4Bmp.GetStatus() == BitMapOkay);
	W4Bmp.SetPosition(Position(3.0, 3.0));
	W4Bmp.Draw();
        W4Bmp.Erase();


        //Load the Third Bitmap
        W5Bmp.Load("yellow.xpm"); //Initial bitmap image is loaded
	assert(W5Bmp.GetStatus() == BitMapOkay);
	W5Bmp.SetPosition(Position(5.0, 5.0));
	W5Bmp.Draw();
        W5Bmp.Erase();


        //Load the Fourth Bitmap
        W6Bmp.Load("blackb.xpm"); //Initial bitmap image is loaded
	assert(W6Bmp.GetStatus() == BitMapOkay);
	W6Bmp.SetPosition(Position(7.0, 7.0));
	W6Bmp.Draw();
        W6Bmp.Erase();



//The fisrt timer starts now and the game begins,The player gets 60 seconds to score as much as he can
//And after these 60 seconds,the game ends!
W1.SetTimerCallback(W2close);
bool TimerStatus1 = W1.StartTimer(60000);
assert(TimerStatus1);


//This timer is responsible for displaying the images at random on the screen based on a given time frame

W2.SetTimerCallback(W2TimerEvent);
bool TimerStatus = W2.StartTimer(900);
assert(TimerStatus); 


 W2.SetMouseClickCallback(Mouseclick1);
}

//Function for the instructions window
void instructions()
{
        W3.Open();
	assert(W3.GetStatus() == WindowOpen);

	// Display the text
	W3.RenderText(Position(7.5,1),Position(11.5,1)," --  SPOT AND HIT  -- ", Red);
        W3.RenderText(Position(1.5,2),Position(4.7,2)," HERE IS HOW YOU PLAY IT : ", Black);
        W3.RenderText(Position(1,3),Position(14,3),"--> The game is based upon the number of successful hits(clicks) you make.  ", Black);
        W3.RenderText(Position(1,4),Position(17.4,4),"--> Each game lasts for 60 seconds. You have to score as much as you can in this time limit.  ", Black);
        W3.RenderText(Position(1,5),Position(18,5),"--> There are basically '4' different balls that can possibly appear at ANY time at ANY location.",Black);
        W3.RenderText(Position(1,6),Position(13.6,6),"--> Each of these balls have a certain score them. These are given below :", Black);
        W3.RenderText(Position(1,7),Position(4.2,7),"--> BLUE Ball : 2 points", Blue);
        W3.RenderText(Position(1,7.5),Position(4.5,7.5),"--> Yellow Ball : 1 point",Black );
        W3.RenderText(Position(1,8),Position(4.5,8),"--> Black Ball : -1 point", Black);         
        W3.RenderText(Position(1,8.5),Position(4.2,8.5),"--> Red Ball : -2 points", Red);      
        
        W3.RenderText(Position(1,9.5),Position(15.7,9.5),"-->Be warned that you will also be panalised with a '-1' for every 'aimless' click.",Black);
        W3.RenderText(Position(1,10.2),Position(13.5,10.2),"'Aimless' click refers to clicks made at all places other than balls.",Black);

        W3.RenderText(Position(1,11),Position(13.5,11),"--> As you keep scoring,the speed at which the balls appear increases ! ", Red);
        W3.RenderText(Position(1,11.5),Position(19.5,11.5)," This increase in speed varies directly with your score (i.e) Higher the score,the faster it gets!!",Black);  

        W3.RenderText(Position(7.85,12.5),Position(11.5,12.5)," GOOD LUCK ", Black); 
}


//Function to carry out operations in the MAIN WINDOW based on Mouseclicks
int Mouseclick(const Position &p)
{     
if(W1Bmp.IsInside(p))
{  
gameinit(); 

}

else if(W7Bmp.IsInside(p))
{
instructions();
}

else if(W2Bmp.IsInside(p))
{ W1.Message("Goodbye");
W1.Close();
 }

return 1;
}



//Function that launches the main window
void initialize()
{       W1.Message("Welcome to SPOT AND HIT");
	// Open the window
	W1.Open();
	assert(W1.GetStatus() == WindowOpen);

	WMBmp.Load("back3.xpm");
	assert(WMBmp.GetStatus() == BitMapOkay);

	// Display the bit maps at a starting position
	WMBmp.SetPosition(Position(0.1, 0.1));
	WMBmp.Draw();

float x;
for(x=0.0;x<14.0;x+=0.01) {
    W1.RenderLine(Position(0.125,9+x), Position(14.0,9+x),
                        Black, 0.0);
  
  } 


        W8Bmp.Load("spot.xpm");
	assert(W8Bmp.GetStatus() == BitMapOkay);

	// Display the bit maps at a starting position
	W8Bmp.SetPosition(Position(0.4, 0.7));
	W8Bmp.Draw();


        W9Bmp.Load("title1.xpm");
	assert(W9Bmp.GetStatus() == BitMapOkay);

	// Display the bit maps at a starting position
	W9Bmp.SetPosition(Position(3.0, 2.5));
	W9Bmp.Draw();

      
        W10Bmp.Load("hit.xpm");
	assert(W10Bmp.GetStatus() == BitMapOkay);

	// Display the bit maps at a starting position
	W10Bmp.SetPosition(Position(5.3, 4.5));
	W10Bmp.Draw();




        W1Bmp.Load("start.xpm");
	assert(W1Bmp.GetStatus() == BitMapOkay);

	// Display the bit maps at a starting position
	W1Bmp.SetPosition(Position(1.0, 10.0));
	W1Bmp.Draw();


        W2Bmp.Load("exit4.xpm");
        assert(W2Bmp.GetStatus() == BitMapOkay);
// Display the bit maps at a starting position
       W2Bmp.SetPosition(Position(7.6, 11.5));
       W2Bmp.Draw();


       W7Bmp.Load("instructions1.xpm");
        assert(W7Bmp.GetStatus() == BitMapOkay);
// Display the bit maps at a starting position
       W7Bmp.SetPosition(Position(6.0,10));
       W7Bmp.Draw();


       W1.SetMouseClickCallback(Mouseclick);
       }


//Main Function 
//The various functions are now invoked logically

int ApiMain() 
{
initialize();
return 0;
}



